import sys
from os import fork, wait

count = int(sys.argv[1]) if len(sys.argv) == 2 else 5
pids = []
message = 'untouched'


def child_main(i):
    global count, pids, message
    print('child {0}: known siblings {1} of {2}'.format(i, len(pids), count))
    message = 'hello from child {0}'.format(i)

for i in range(count):
    child_pid = fork()
    if child_pid:
        pids.append(child_pid)
        print('parent: forked {0}'.format(child_pid))
    else:
        child_main(i)
        sys.exit(0)

for i in range(count):
    exit_pid, exit_status = wait()
    print('parent: child {0} ({1}) exited with {2}'.format(pids.index(exit_pid), exit_pid, exit_status))

print('parent: message is {0}'.format(message))
