import sys
import time
from multiprocessing import Process, Queue

count = int(sys.argv[1]) if len(sys.argv) == 2 else 5

def consumer_main(name, q):
    while True:
        msg = q.get()
        if msg is None:
            print('child {0}: exit'.format(name))
            return
        print('child {0}: {1} from parent'.format(name, msg))
        time.sleep(0.1)

q = Queue()
consumers = [Process(target=consumer_main, args=(name, q)) for name in range(count)]
for c in consumers:
    c.start()
for i in range(20):
    q.put('hello {0}'.format(i))
for c in consumers:
    q.put(None)
    # c.join() why we don't join here?
for c in consumers:
    c.join()
