import time
from threading import Thread, Condition

condvar = Condition()
items_available = 0
stop = False

def consumer(name, required):
    global condvar, items_available
    while True:
        with condvar:
            while items_available < required and not stop: #print('C {0}: wakeup items={1} stop={2}'.format(name, items_available, stop))
                condvar.wait()
            if stop:
                print('C {0}: out of items'.format(name))
                return
            items_available -= required
            print('C {0}: got {1} items'.format(name, required))
        # here we do the processing
        time.sleep(1)

def producer(upto):
    global items_available, stop
    for i in range(upto):
        with condvar:
            print('P  : item {0} of {1}'.format(i, upto))
            items_available += 1
            condvar.notify()
        time.sleep(0.2)
    with condvar:
        print('  P: done')
        stop = True
        condvar.notify_all()

c1 = Thread(target=consumer, args=(0, 2))
c2 = Thread(target=consumer, args=(1, 3))
p = Thread(target=producer, args=(20,))

c1.start()
c2.start()
p.start()

c1.join()
c2.join()
p.join()
